# © 2020-2022 Le Filament (<http://www.le-filament.com>)
# License AGPL-3.0 or later (http://www.gnu.org/licenses/agpl.html).

from io import BytesIO

from odoo import http
from odoo.http import request

from odoo.addons.web.controllers.main import content_disposition, serialize_exception


class GapExport(http.Controller):
    @http.route(["/web/export_gap/"], type="http", auth="user")
    @serialize_exception
    def datas_export(self, filename_, project_id, partner_type, **kw):

        workbook = request.env["project.project"].get_workbook(
            filename_, project_id, partner_type
        )

        fp = BytesIO()
        workbook.save(fp)
        fp.seek(0)
        data = fp.read()
        fp.close()

        filename = "Export_" + partner_type + "_" + filename_ + ".xls"

        xlshttpheaders = [
            ("Content-Type", "text/csv;charset=utf8"),
            ("Content-Disposition", content_disposition(filename)),
        ]

        return request.make_response(data, headers=xlshttpheaders)
