odoo.define('adefpat_project.widget', function(require) {
    "use strict";

    var AbstractField = require('web.AbstractField');
    var registry = require('web.field_registry');

    /**
     * This widget is intended to be used on boolean fields.
     * It displays 1 when True and 0 when False.
    */
    var FieldIntBoolean = AbstractField.extend({
        template: "IntBool",
        supportedFieldTypes: ['boolean'],

        //--------------------------------------------------------------------------
        // Public
        //--------------------------------------------------------------------------
        /**
         * Prepares the rendering so that it creates an element the user can type
         * text into in edit mode.
         *
         * @override
         */
        init: function () {
            this._super.apply(this, arguments);
            if (this.value === true) {
                this.int_value = 1;
            } else {
                this.int_value = 0;
            }
        },
        /**
         * A boolean field is always set since false is a valid value.
         *
         * @override
         */
        isSet: function () {
            return true;
        },
    });

    registry.add('boolean_integer', FieldIntBoolean);
});
